﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace bnlstest
{
    class Buffer
    {
        private byte[] buffer;

        public Buffer()
        {
            buffer = new byte[0];
        }
        public Buffer(byte[] b)
        {
            buffer = b;
        }

        public void Add(byte b)
        {
            byte[] tmp = buffer;
            buffer = new byte[tmp.Length + 1];
            for (int count = 0; count < tmp.Length; ++count)
                buffer[count] = tmp[count];
            buffer[buffer.Length - 1] = b;
        }
        public void Add(byte[] b)
        {
            byte[] tmp = buffer;
            buffer = new byte[tmp.Length + b.Length];
            for (int count = 0; count < tmp.Length; count++)
                buffer[count] = tmp[count];
            for (int count = tmp.Length; count < buffer.Length; count++)
                buffer[count] = b[count - tmp.Length];
        }
        public void Add(string s)
        {
            Add(new ASCIIEncoding().GetBytes(s));
        }
        public void Add(uint u)
        {
            Add(BitConverter.GetBytes(u));
        }
        public void Add(int i)
        {
            Add(BitConverter.GetBytes(i));
        }

        public byte[] Data
        {
            get
            {
                return buffer;
            }
            set
            {
                buffer = value;
            }
        }
        /// <summary>
        /// returns a sub-array starting with "begin" up to (but not including) "end"
        /// </summary>
        /// <param name="begin">Will be included in result</param>
        /// <param name="end">Will NOT be included in result</param>
        /// <returns></returns>
        public byte[] Sub(int begin, int end)
        {
            byte[] tmp = new byte[end - begin];
            for (int count = begin; count < end; ++count)
                tmp[count - begin] = buffer[count];
            return tmp;
        }
        public byte[] Encode()
        {
            byte[] encoded;
            // i add buffer % 7 before the division so that it comes out even
            // if i didn't, the whole packet wouldnt fit. extra parts are 0's
            // this splits buffer into groups of 7, the first byte of the group
            // is the key, so multiply by 8 to get the total size of the buffer.
            int length = ((buffer.Length + (buffer.Length % 7)) / 7) * 8;
            encoded = new byte[length];
            int bufferCount = 0; // keeps track of the position in the actual buffer

            for (int count = 0; count < encoded.Length; count += 8)
            {
                // first bit = 1 for the "key" byte
                encoded[count] = 0x01;
                // for each of the next 7, the first bit is put into
                // the key bit in the corrisponding bit (ei, byte2 goes to bit2)
                for (int count2 = 1; count2 < 8; count2++)
                {
                    // mod 2, which returns if the number is even or odd (first byte)
                    encoded[count] |= (byte)((byte)(buffer[bufferCount] % 2) << count2);
                    encoded[count2 + count] = buffer[bufferCount++];

                    // sets the last byte to 1
                    encoded[count2 + count] |= (byte)0x01;
                }
            }

            return encoded;
        }
        public byte[] Decode(byte[] encoded)
        {
            byte[] decoded;
            int length = (encoded.Length / 8) * 7;
            decoded = new byte[length];
            for (int count = 0; count < encoded.Length; count += 8)
            {
                byte key = encoded[count];
                for (int count2 = 1; count2 < 8; count2++)
                {

                }
            }
            return new byte[0];
        }
    }
}